Denys Vlasenko | 10c01a7 | 2016-12-23 13:39:22 +0100 | [diff] [blame] | 1 | #!/bin/sh |
| 2 | # This script expects that the tree was built with the desired .config: |
| 3 | # in particular, it expects that include/applets.h is generated already. |
| 4 | # |
| 5 | # The script will try to rebuild each enabled applet in isolation. |
| 6 | # All other options which chose general bbox config, applet features, etc, |
| 7 | # are not modified for the builds. |
| 8 | |
| 9 | makeopts="-j9" |
| 10 | |
| 11 | # The list of all applet config symbols |
| 12 | test -f include/applets.h || { echo "No include/applets.h file"; exit 1; } |
| 13 | apps="` |
| 14 | grep ^IF_ include/applets.h \ |
| 15 | | grep -v ^IF_FEATURE_ \ |
| 16 | | sed 's/IF_\([A-Z0-9._-]*\)(.*/\1/' \ |
Denys Vlasenko | 10c01a7 | 2016-12-23 13:39:22 +0100 | [diff] [blame] | 17 | | sort | uniq |
| 18 | `" |
| 19 | |
| 20 | # Take existing config |
| 21 | test -f .config || { echo "No .config file"; exit 1; } |
| 22 | cfg="`cat .config`" |
| 23 | |
| 24 | # Make a config with all applet symbols off |
| 25 | allno="$cfg" |
| 26 | for app in $apps; do |
| 27 | allno="`echo "$allno" | sed "s/^CONFIG_${app}=y\$/# CONFIG_${app} is not set/"`" |
| 28 | done |
Denys Vlasenko | 0b88358 | 2016-12-23 16:49:07 +0100 | [diff] [blame] | 29 | #echo "$allno" >.config_allno |
Denys Vlasenko | 10c01a7 | 2016-12-23 13:39:22 +0100 | [diff] [blame] | 30 | |
| 31 | # Turn on each applet individually and build single-applet executable |
| 32 | fail=0 |
| 33 | for app in $apps; do |
| 34 | # Only if it was indeed originally enabled... |
| 35 | { echo "$cfg" | grep -q "^CONFIG_${app}=y\$"; } || continue |
| 36 | |
| 37 | echo "Making ${app}..." |
| 38 | mv .config .config.SV |
| 39 | echo "CONFIG_${app}=y" >.config |
| 40 | echo "$allno" | sed "/^# CONFIG_${app} is not set\$/d" >>.config |
Denys Vlasenko | 0b88358 | 2016-12-23 16:49:07 +0100 | [diff] [blame] | 41 | |
Denys Vlasenko | 7d5c881 | 2016-12-23 19:42:53 +0100 | [diff] [blame^] | 42 | if test x"${app}" != x"SH_IS_ASH" && test x"${app}" != x"SH_IS_HUSH"; then |
| 43 | # $allno has all choices for "sh" aliasing set to off. |
Denys Vlasenko | 0b88358 | 2016-12-23 16:49:07 +0100 | [diff] [blame] | 44 | # "sh" aliasing defaults to "ash", not none. |
| 45 | # without this fix, "make oldconfig" sets it wrong, |
Denys Vlasenko | 7d5c881 | 2016-12-23 19:42:53 +0100 | [diff] [blame^] | 46 | # resulting in NUM_APPLETS = 2 (the second applet is "sh") |
Denys Vlasenko | 0b88358 | 2016-12-23 16:49:07 +0100 | [diff] [blame] | 47 | sed '/CONFIG_SH_IS_NONE/d' -i .config |
| 48 | echo "CONFIG_SH_IS_NONE=y" >>.config |
| 49 | fi |
| 50 | |
Denys Vlasenko | 10c01a7 | 2016-12-23 13:39:22 +0100 | [diff] [blame] | 51 | if ! yes '' | make oldconfig >busybox_make_${app}.log 2>&1; then |
| 52 | : $((fail++)) |
| 53 | echo "Config error for ${app}" |
| 54 | mv .config busybox_config_${app} |
Denys Vlasenko | 7d5c881 | 2016-12-23 19:42:53 +0100 | [diff] [blame^] | 55 | elif ! make $makeopts >>busybox_make_${app}.log 2>&1; then |
Denys Vlasenko | 10c01a7 | 2016-12-23 13:39:22 +0100 | [diff] [blame] | 56 | : $((fail++)) |
| 57 | echo "Build error for ${app}" |
| 58 | mv .config busybox_config_${app} |
Denys Vlasenko | a1cd0d9 | 2016-12-23 15:12:27 +0100 | [diff] [blame] | 59 | elif ! grep -q '^#define NUM_APPLETS 1$' include/NUM_APPLETS.h; then |
| 60 | mv busybox busybox_${app} |
| 61 | : $((fail++)) |
| 62 | echo "NUM_APPLETS != 1 for ${app}: `cat include/NUM_APPLETS.h`" |
| 63 | mv .config busybox_config_${app} |
Denys Vlasenko | 10c01a7 | 2016-12-23 13:39:22 +0100 | [diff] [blame] | 64 | else |
| 65 | mv busybox busybox_${app} |
| 66 | rm busybox_make_${app}.log |
| 67 | fi |
| 68 | mv .config.SV .config |
| 69 | #exit |
| 70 | done |
Denys Vlasenko | a1cd0d9 | 2016-12-23 15:12:27 +0100 | [diff] [blame] | 71 | touch .config # or else next "make" can be confused |
Denys Vlasenko | 10c01a7 | 2016-12-23 13:39:22 +0100 | [diff] [blame] | 72 | echo "Failures: $fail" |
| 73 | test $fail = 0 # set exitcode |